import java.util.ArrayList;

/**
An event defined in the model.

@author Michael Breen
*/
public final class Event
{
   /** A list of all the events. */
   private static ArrayList events = new ArrayList();

<#list doc.model.events.event as event>
   <#if event.description?size != 0>
      <@prologue_comment event.description/>
   </#if>
   public static final Event ${event_id(event)} =
      new Event("${event.@name}");
</#list>

   /** This event's identifier as defined in the model. */
   private String id;

   /** This event's index in the list of variables. */
   private int listIndex;

   /**
   Get the number of events.
   @return the total number of events
   */
   public static int numEvents() { return Event.events.size(); }

   /**
   Get an event from its number.
   @param index a number in the range
   0 .. ({@link #numEvents()} - 1)
   @return the event at the specified index in the list of
   all events
   */
   public static Event getEvent(int index)
   {
      return (Event) Event.events.get(index);
   }

   /** @param name the new event's identifier */
   private Event(String name)
   {
      this.id = name;
      this.listIndex = Event.events.size();
      Event.events.add(this);
   }

   /**
   The string representation of an event is its name
   in the model.
   @return this event's identifier in the model
   */
   public String toString() { return this.id; }

   /**
   Get the number of this event.
   @return a number in the range 0 .. ({@link #numEvents()} - 1)
   */
   public int getIndex() { return this.listIndex; }
}
